<?php
/**
* @package	WDTech
* @copyright	Copyright (C) 2009 WDTech.Net. All rights reserved.
*		Modificato da David Bigagli (david.bigagli@gmail.com) per supportare moduli multipli nello stesso template e anche di tipo flash
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

$banners = array();
$jsBanners = array();
$jsLinks = array();
$suffix = $params->get('suffix'); if ( $suffix ) $suffix = "_suffix$suffix"; else $suffix='';
for ($i=1; $i<=10; $i++) {
	$flash = "0";
	$imageUrl = $params->get('banner_image_url_'.$i);
	$imageLink = $params->get('banner_link_'.$i);
	if ( strtolower( substr( $imageUrl, -3 ) ) == 'swf' )
		$flash = "1";
	
	if (!empty($imageUrl) && ( !empty($imageLink) or $flash ) ) {
		$jsBanners[] = "\"{$imageUrl}\"";
		$jsLinks[] = "\"{$imageLink}\"";
		$jsFlash[] = "\"{$flash}\"";
		$banners[] = array(
			'flash' => $flash,
			'image' => $imageUrl,
			'link'  => $imageLink
		);
	}
}

$isRandom = ($params->get('show_random') == 1);
$isFixedSize = ($params->get('fixed_size') == 1);
$width = $params->get('width');
$height = $params->get('height');
$target = $params->get('target');
$delayTime = $params->get('delay_time');

if ($isRandom) {
	$banner = $banners[mt_rand(0, count($banners) - 1)];
} else {
	$logFile = dirname(__FILE__).DS.'last_show'.$suffix.'.txt';
	if (!is_file($logFile)) {
		touch($logFile);
		
		$fp = fopen($logFile, 'w');
		fwrite($fp, '-1');
		fclose($fp);
	}
	
	$lastBannerIndex = intval(file_get_contents($logFile));
	if ((time() - filemtime($logFile)) > $delayTime) {
		$nextBannerIndex = $lastBannerIndex + 1;
		if (!isset($banners[$nextBannerIndex])) $nextBannerIndex = 0;
		
		$fp = fopen($logFile, 'w');
		fwrite($fp, $nextBannerIndex);
		fclose($fp);
	} else {
		$nextBannerIndex = ($lastBannerIndex < 0) ? 0 : $lastBannerIndex;
	}
	
	$banner = $banners[$nextBannerIndex];
}

$doc = &JFactory::getDocument();

if ($isFixedSize) {
	$css = "
		#wdBanners{$suffix} {
			width: {$width}px; height: {$height}px; overflow: hidden;
		}
		#wdBanners{$suffix} img {
			border: 0px;
		}
	";
	$doc->addStyleDeclaration($css);
}

$delayTime = $delayTime * 1000;
$showRandom = ($isRandom) ? 1 : 0;
$javascript = "	
	var flashban{$suffix} = new Array(".implode(', ', $jsFlash).");
	var images{$suffix} = new Array(".implode(', ', $jsBanners).");
	var links{$suffix} = new Array(".implode(', ', $jsLinks).");

	var currentAd{$suffix} = 0;
	var showRandom{$suffix} = {$showRandom};

	function wdRotator{$suffix}() {

		var sb = document.getElementById('sb-container');

		if (currentAd{$suffix} == images{$suffix}.length) {
			currentAd{$suffix} = 0;
		}
		
		// Se non è un banner in flash imposta l'immagine
		if ( flashban{$suffix}[currentAd{$suffix}] == 0 ) {
			var bannerUrl = document.getElementById('wdBannerLink{$suffix}');
			var bannerImg = document.getElementById('wdBannerImg{$suffix}');

			bannerUrl.href=links{$suffix}[currentAd{$suffix}];
			bannerImg.src=images{$suffix}[currentAd{$suffix}];
		}
		else if ( flashban{$suffix}[currentAd{$suffix}] == 1 ) {
			if ( sb ) {
				if ( sb.style.display == \"block\" )
					return;
			}
			/*
			var bannerFlash = document.getElementById('wdBannerFlash{$suffix}');
			bannerFlash.src=images{$suffix}[currentAd{$suffix}];
			*/
			var bannerDivFlash = document.getElementById('wdBanners{$suffix}');
			bannerDivFlash.innerHTML = \"<embed id='wdBannerFlash{$suffix}' width='{$width}' height='{$height}' type='application/x-shockwave-flash' pluginspage='http://www.macromedia.com/go/getflashplayer' src='\"+images{$suffix}[currentAd{$suffix}]+\"' play='true' loop='true' menu='true'></embed>\";
		}
		
		if (showRandom{$suffix} == 1) {
			currentAd{$suffix} = Math.round((Math.random()*(images{$suffix}.length-1)) + 1);
		} else {
			currentAd{$suffix}++;
		}
	}
	window.setInterval(\"wdRotator{$suffix}()\", {$delayTime});
";

$doc->addScriptDeclaration($javascript);
?>
<div class="wdBanners" id="wdBanners<?php echo $suffix?>">
	<!-- Banner come immagine -->
	<?php if ( $banner['flash'] == "0" ): ?>
		<?php if($target == 0): ?>
			<a href="<?php echo $banner['link'] ?>" id="wdBannerLink<?php echo $suffix?>"><img src="<?php echo $banner['image'] ?>" id="wdBannerImg<?php echo $suffix?>" /></a>
		<?php else: ?>
			<a href="<?php echo $banner['link'] ?>" target="_blank" id="wdBannerLink<?php echo $suffix?>"><img src="<?php echo $banner['image'] ?>" id="wdBannerImg<?php echo $suffix?>" /></a>
		<?php endif; ?>
	<!-- Banner come flash -->
	<?php else : ?>
		<embed id="wdBannerFlash<?php echo $suffix?>" width="<?php echo $width?>" height="<?php echo $height?>" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" src="<?php echo $banner['image'] ?>" play="true" loop="true" menu="true"></embed>
	<?php endif; ?>
</div>
